<template>
  <div id="entities" class="imageList panel">
    <img
      v-for="entity in entityList"
      :key="entity.name"
      :src="
        require(`../../../../assets/images/${entity.tileset.name}/${entity.imageTilesetPosition}.png`)
      "
      :class="'image ' + (selectedEntityName === entity.name ? 'selected' : '')"
      @click="$emit('selectedEntity', entity.name)"
    />
  </div>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */

import { Component, Vue, Prop } from "vue-property-decorator";
import { Entity } from "../../../../services/editor/entities";

@Component
export default class EntitySelector extends Vue {
  @Prop() entityList!: Entity[];
  @Prop() selectedEntityName!: string;
}
</script>

<style scoped>
.imageList {
  display: flex;
  gap:5px;
}

.image {
  cursor: pointer;
  width: 34px;
  image-rendering: -moz-crisp-edges;
  image-rendering: -webkit-crisp-edges;
  image-rendering: pixelated;
  image-rendering: crisp-edges;
}
.image:hover {
  opacity: 0.5;
  z-index: 1;
}
.image.selected {
  filter: drop-shadow(0 0 5px rgb(255, 255, 255));
  z-index: 1;
}
#entities img {
  width: 27px;
  object-fit: cover;
}
</style>
